﻿using Syncfusion.SfDataGrid.XForms;
using Syncfusion.SfDataGrid.XForms.Exporting;
using System;
using System.Collections.Generic;
using System.IO;
using System.Reflection;
using System.Text;
using System.Windows.Input;
using Xamarin.Forms;

namespace DataGrithWithImagePdfExport.ViewModels
{
    public class MainPageViewModel
    {
        public MainPageViewModel()
        {
            Assembly a = this.GetType().Assembly;

            Stream stream = a.GetManifestResourceStream("DataGrithWithImagePdfExport.Resources.genericface.jpg");

            ImageSource source = ImageSource.FromStream(()=> stream);

            Persons.Add(new Person() { Name = "John Smith", Photo = source });

            ExportCommand = new Command(HandleExport);

        }

        private void HandleExport(object obj)
        {
            try
            {
                DataGridPdfExportingController pdfExport = new DataGridPdfExportingController();
                MemoryStream stream = new MemoryStream();
                var exportToPdf = pdfExport.ExportToPdf(DataGrid, new DataGridPdfExportOption()
                {
                    FitAllColumnsInOnePage = true,
                });
                exportToPdf.Save(stream);
                exportToPdf.Close(true);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        public SfDataGrid DataGrid { get; set; }

        public ICommand ExportCommand { get; set; }

        public List<Person> Persons { get; set; } = new List<Person>();
    }

    public class Person
    {
        public string Name { get; set; } = string.Empty;

        public ImageSource Photo { get; set; } = string.Empty;
    }
}
